<?php
/**
 * Plugin Name: Custom Post Display
 * Plugin URI: http://www.crispuno.ca/?p=228
 * Description: Display content of custom posts types in a widget
 * Version: 1.1
 * Author: Cris Puno
 * Author URI: http://www.crispuno.ca/
 */
// Released under the GPL license
// http://www.opensource.org/licenses/gpl-license.php


//Word Trimmer


class CustomPostsContent extends WP_Widget {

    function CustomPostsContent() {
        $this->WP_Widget('CustomPostsContent', '侧边栏:产品文章显示', array('description' => '产品文章显示'));
    }

    function widget($args, $instance) {		
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);
	    $posttype = $instance['posttype'];
		$postnum = $instance['postnum'];
		$byorder = $instance['byorder'];
		$sorter = $instance['sorter'];
       echo $before_widget; 
			 if ( $title )
                 echo $before_title . $title .$after_title; 
			$loop = new WP_Query( array( 'post_type' => $posttype, 'posts_per_page' => $postnum, 'orderby'=> $byorder ,'order'=> $sorter) ); 
			while ( $loop->have_posts()) {
			$loop->the_post(); 
						
					echo '<ul class="cp">';
					echo "<li><a href='";
					echo the_permalink();
					echo "'>";
					echo the_title();
					echo "</a></li>";
					
					
			} 

			echo '</ul>';
          echo $after_widget;
    }


    function update($new_instance, $old_instance) {				
	$instance = $old_instance;
	$instance['title'] = strip_tags($new_instance['title']);
	$instance['posttype'] = $new_instance['posttype'];
	$instance['postnum'] = strip_tags($new_instance['postnum']);
	$instance['byorder'] = $new_instance['byorder'];
	$instance['sorter'] = $new_instance['sorter'];
        return $instance;
    }


    function form($instance) {				
		$defaults = array( 'title' => '产品文章',  'postnum'=> 10, 'postlength'=>15);
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>
         <p>
          <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $instance['title']; ?>" />
        </p>
		<p>
		<?php global $wp_post_types; ?>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
		<label for="<?php echo $this->get_field_id( 'posttype' ); ?> "><?php _e('选择文章类型:', 'CustomPostsContent'); ?></label>
		<select id="<?php echo $this->get_field_id( 'posttype' ); ?>" name="<?php echo $this->get_field_name( 'posttype' ); ?>">
		<?php 
		global $wpdb;
		$ptypesql = "SELECT DISTINCT post_type FROM $wpdb->posts WHERE post_type <> 'media' AND post_type <> 'attachment' AND post_type <> 'revision' AND post_type <> 'nav_menu_item'"; 
		$ptypequery = $wpdb->get_results($ptypesql);
		foreach ( $ptypequery as $ptype) {
		$post_type = $ptype->post_type; ?>
		<option value="<?php echo $post_type ?>" <?php if ( $instance['posttype'] == $post_type ){ echo 'selected="selected"'; }?>><?php echo $wp_post_types[$post_type]->labels->name; ?></option>
		<?php }
		?>             
		</select>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'postnum' ); ?>">显示文章数目:</label>
			<input id="<?php echo $this->get_field_id( 'postnum' ); ?>" name="<?php echo $this->get_field_name( 'postnum' ); ?>" value="<?php echo $instance['postnum']; ?>" style="width:90%;" />
		</p>
		
		
		<p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
		<label for="<?php echo $this->get_field_id( 'byorder' ); ?> "><?php _e('排序:', 'CustomPostsContent'); ?></label>
		<select id="<?php echo $this->get_field_id( 'byorder' ); ?>" name="<?php echo $this->get_field_name( 'byorder' ); ?>">
		<option value="" <?php if ( $instance['byorder'] == '' ){ echo 'selected="selected"'; }?>>按发布时间</option>      
		
		<option value="name" <?php if ( $instance['byorder'] == 'name' ){ echo 'selected="selected"'; }?>>按标题</option>    
		</select>
		</p>
		<p>                                                                                                                                                                                                                                                                                                                                                                                                                                                           <label for="<?php echo $this->get_field_id( 'sorter' ); ?> "><?php _e('升降排序:', 'CustomPostsContent'); ?></label>
		<select id="<?php echo $this->get_field_id( 'sorter' ); ?>" name="<?php echo $this->get_field_name( 'sorter' ); ?>">
		<option value="ASC" <?php if ( $instance['sorter'] == 'ASC' ){ echo 'selected="selected"'; }?>>升序</option>      
		<option value="DESC" <?php if ( $instance['sorter'] == 'DESC' ){ echo 'selected="selected"'; }?>>降序</option>    
		</select>
		</p>
		

        <?php 
    }

} // class CustomPostsContent

// register CustomPostsContent widget
add_action('widgets_init', create_function('', 'return register_widget("CustomPostsContent");'));                                                                                                                                                             