<?php  

//widget creekoo_mainpost

add_action('widgets_init', create_function('', 'return register_widget("creekoo_mainposts");'));

class creekoo_mainposts extends WP_Widget {
	function creekoo_mainposts() {
		$this->WP_Widget('creekoo_mainposts', '内容区：文章推荐 ', array( 'description' => '缩略图+标题形式（评论、时间、随机排列）' ));
	}
	function widget($args, $instance) {
		extract($args, EXTR_SKIP);
		echo $before_widget;
		$title        = apply_filters('widget_name', $instance['title']);
		$limit        = $instance['limit'];
		$cat          = $instance['cat'];
		$orderby      = $instance['orderby'];
        
        echo $before_title.$title.$after_title; 
		echo '<div class="mainposts">';
		echo creekoo_mainposts_list( $orderby,$limit,$cat );
		echo '<div class="clear"></div></div>';
		echo $after_widget;

	}
	function update($new_instance, $old_instance) {
		$instance                 = $old_instance;
		$instance['title']        = strip_tags($new_instance['title']);
		$instance['limit']        = strip_tags($new_instance['limit']);
		$instance['cat']          = strip_tags($new_instance['cat']);
		$instance['orderby']      = strip_tags($new_instance['orderby']);
		return $instance;
	}
	function form($instance) {
		$instance = wp_parse_args( (array) $instance, array( 
			'title'        => '文章推荐',
			'limit'        => '8',
			'cat'          => '',
			'orderby'      => 'date',
			) 
		);
		$title        = strip_tags($instance['title']);
		$limit        = strip_tags($instance['limit']);
		$cat          = strip_tags($instance['cat']);
		$orderby      = strip_tags($instance['orderby']);
?>

		<p>
			<label>
				标题：
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $instance['title']; ?>" />
			</label>
		</p>

		<p>
			<label>
				排序：
				<select class="widefat" id="<?php echo $this->get_field_id('orderby'); ?>" name="<?php echo $this->get_field_name('orderby'); ?>" style="width:100%;">
					<option value="comment_count" <?php selected('comment_count', $instance['orderby']); ?>>按评论数</option>
					<option value="date" <?php selected('date', $instance['orderby']); ?>>按发布时间</option>
					<option value="rand" <?php selected('rand', $instance['orderby']); ?>>随机显示</option>
				</select>
			</label>
		</p>
		<p>
			<label>
				分类限制：
				<a style="font-weight:bold;color:#f60;text-decoration:none;" href="javascript:;" title="格式：1,2 &nbsp;表示限制ID为1,2分类的文章&#13;格式：-1,-2 &nbsp;表示排除分类ID为1,2的文章&#13;也可直接写1或者-1；注意逗号须是英文的">？</a>
				<input class="widefat" id="<?php echo $this->get_field_id('cat'); ?>" name="<?php echo $this->get_field_name('cat'); ?>" type="text" value="<?php echo attribute_escape($cat); ?>" size="24" />
			</label>
		</p>
		<p>
			<label>
				显示数目：
				<input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="number" value="<?php echo attribute_escape($limit); ?>" size="24" />
			</label>
		</p>
<?php
	}
}

function creekoo_mainposts_list($orderby,$limit,$cat) {
	$args = array(
		'order'            => DESC,
		'cat'              => $cat,
		'orderby'          => $orderby,
		'showposts'        => $limit,
		'caller_get_posts' => 1
	);
	query_posts($args);

	while (have_posts()) : the_post(); ?>
            
			<div class="hotshopbox">
		<a href="<?php the_permalink() ?>" rel="bookmark" title="<?php the_title(); ?>">
		<?php if (has_post_thumbnail()) { the_post_thumbnail('thumbnail'); }
		else { ?>
		<img class="home-thumb" src="<?php echo catch_first_image() ?>" width="120px" height="120px" alt="<?php the_title(); ?>"/>
		<?php } ?>
		</a></div>

    <?php endwhile; wp_reset_query();
}

?>