<?php  

//widget creekoo_hotpost

add_action('widgets_init', create_function('', 'return register_widget("creekoo_hotpost");'));

class creekoo_hotpost extends WP_Widget {
	function creekoo_hotpost() {
		$this->WP_Widget('creekoo_hotpost', '侧边栏：文章推荐 ', array( 'description' => '文章列表（评论、时间、随机排列）' ));
	}
	function widget($args, $instance) {
		extract($args, EXTR_SKIP);
		echo $before_widget;
		$title        = apply_filters('widget_name', $instance['title']);
		$limit        = $instance['limit'];
		$cat          = $instance['cat'];
		$orderby      = $instance['orderby'];

		echo $before_title.$title.$after_title; 
		echo '<ul>';
		echo creekoo_posts_list( $orderby,$limit,$cat );
		echo '</ul>';
		echo $after_widget;
	}
	function update($new_instance, $old_instance) {
		$instance                 = $old_instance;
		$instance['title']        = strip_tags($new_instance['title']);
		$instance['limit']        = strip_tags($new_instance['limit']);
		$instance['cat']          = strip_tags($new_instance['cat']);
		$instance['orderby']      = strip_tags($new_instance['orderby']);
		return $instance;
	}
	function form($instance) {
		$instance = wp_parse_args( (array) $instance, array( 
			'title'        => '文章推荐',
			'limit'        => '10',
			'cat'          => '',
			'orderby'      => 'date',
			) 
		);
		$title        = strip_tags($instance['title']);
		$limit        = strip_tags($instance['limit']);
		$cat          = strip_tags($instance['cat']);
		$orderby      = strip_tags($instance['orderby']);
?>

		<p>
			<label>
				标题：
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $instance['title']; ?>" />
			</label>
		</p>

		<p>
			<label>
				排序：
				<select class="widefat" id="<?php echo $this->get_field_id('orderby'); ?>" name="<?php echo $this->get_field_name('orderby'); ?>" style="width:100%;">
					<option value="comment_count" <?php selected('comment_count', $instance['orderby']); ?>>按评论数</option>
					<option value="date" <?php selected('date', $instance['orderby']); ?>>按发布时间</option>
					<option value="rand" <?php selected('rand', $instance['orderby']); ?>>随机显示</option>
				</select>
			</label>
		</p>
		<p>
			<label>
				分类限制：
				<a style="font-weight:bold;color:#f60;text-decoration:none;" href="javascript:;" title="格式：1,2 &nbsp;表示限制ID为1,2分类的文章&#13;格式：-1,-2 &nbsp;表示排除分类ID为1,2的文章&#13;也可直接写1或者-1；注意逗号须是英文的">？</a>
				<input class="widefat" id="<?php echo $this->get_field_id('cat'); ?>" name="<?php echo $this->get_field_name('cat'); ?>" type="text" value="<?php echo attribute_escape($cat); ?>" size="24" />
			</label>
		</p>
		<p>
			<label>
				显示数目：
				<input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="number" value="<?php echo attribute_escape($limit); ?>" size="24" />
			</label>
		</p>
<?php
	}
}

function creekoo_posts_list($orderby,$limit,$cat) {
	$args = array(
		'order'            => DESC,
		'cat'              => $cat,
		'orderby'          => $orderby,
		'showposts'        => $limit,
		'caller_get_posts' => 1
	);
	query_posts($args);
	while (have_posts()) : the_post(); 

		echo '<li><a href="'.get_permalink().'">'.get_the_title().'</a></li>';
	
    endwhile; wp_reset_query();
}

?>